local fishing = {
	3567,4598,6256,6365,6366,6367,
	7996,12225,19022,19969,19970,
	19972,25978,33820,44050,45858,
	45991,45992,50287, 46106, 46069,
	46070, 46349}
local enchants = {846,2603,3269}
local msg

local function IsInstance()

	local inInstance, instanceType = IsInInstance()
	local ininstance = false

	if (inInstance ~= nil) then

		if (instanceType ~= "none") then

  			ininstance = true

		end

	end

  	return ininstance

end

local function fadeOut(self, elapsed)

	local fadetime = Kipper.frame.fadetime + elapsed

	if (fadetime < 2) then

		Kipper.frame.fadetime = fadetime

	else

		Kipper.frame:SetScript("OnUpdate", nil)
		Kipper.frame.fadetime = 0
		UIFrameFadeOut(Kipper.frame, 4, 1, 0)

	end
	
end

local function setMsg(item)

	msg:SetText(string.format(Kipper.ALERT, item))
	Kipper.frame:Show()
	PlaySound("RaidWarning")
	Kipper.frame:SetScript("OnUpdate", fadeOut)

end

local function checkGear()

	local slot, itemid, ench
	local ilink, i
	local found, fishitem
	local result

	found = nil
	result = 1

	for slot = 0, 16 do

		ilink = GetInventoryItemLink("Player", slot)

		if (ilink) then

			_, _, _, _, itemid, ench = string.find(ilink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")


			for i, fishitem in ipairs(fishing) do

				result = itemid - fishitem


				if (result == 0) then

					found = ilink
					break
	
				end
	
			end

			if (found) then

				break

			end

			for i, enchant in pairs(enchants) do

				result = ench - enchant

				if (result == 0) then

					found = ilink
					break
	
				end

			end

			if (found) then

				break

			end

		end

	end

	if (found) then

		setMsg(found)

	end		

end

local function eventHandler(self, event, ...)

	local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
	local spellId, spellName, spellSchool = select(9, ...)

	if (event == "ZONE_CHANGED_NEW_AREA") then


		if (IsInstance() == true) then

			checkGear()

		end

	elseif (event == "PLAYER_LOGIN") then

		if (msg == nil) then

			msg = Kipper.frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
			msg:SetFont("Fonts\\FRIZQT__.TTF",32)
			msg:SetPoint("CENTER", Kipper.frame, "CENTER", 0, 0)

		end
		
	end

end

Kipper.frame = CreateFrame("Frame","Kipper",UIParent)
Kipper.frame:Hide()
Kipper.frame.fadetime = 0
Kipper.frame:SetFrameStrata("DIALOG")
Kipper.frame:SetHeight(50)
Kipper.frame:SetWidth(UIParent:GetWidth())
Kipper.frame:SetPoint("CENTER", UIParent, "CENTER", 0, 200)
Kipper.frame:RegisterEvent("PLAYER_LOGIN")
Kipper.frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Kipper.frame:SetScript("OnEvent", function(...) eventHandler(...) end)